<?php

namespace Kaitek\Bundle\FrameworkBundle\Repository;

use Doctrine\ORM\EntityRepository;
use Kaitek\Bundle\FrameworkBundle\Model\OnlineLoaderInterface;
#use Kaitek\Bundle\FrameworkBundle\Exception\OnlineUserIdNotFoundException;
/**
 * OnlineRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class OnlineRepository extends EntityRepository
{
    
    public function loadOnlineByUserInfo($user, $sessionId, $ms) {
        if(!$ms){
            $qb=$this->createQueryBuilder('o')
                ->update()
                ->join('o.user', 'u', 'with', 'u.id = :userId')
                ->set('o.active',0)
                ->where('o.active=1 and o.sessionId <> :sessionId')
                ->setParameter('userId', $user->getId())
                ->setParameter('sessionId', $sessionId)
                ->getQuery()
                ->getResult();
        }
        $online = $this->createQueryBuilder('o')
            ->where('o.active=1 and o.sessionId = :sessionId')
            ->join('o.user', 'u', 'with', 'u.id = :userId')
            ->setParameter('userId', $user->getId())
            ->setParameter('sessionId', $sessionId)
            ->getQuery()
            ->setMaxResults(1)
            ->getOneOrNullResult();

        /*if (null === $online) {
            $message = sprintf(
                'Unable to find a menu KaitekFrameworkBundle:Online object identified by "%s".',
                $userId
            );
            throw new OnlineUserIdNotFoundException($message);
        }*/

        return $online;
    }

    public function loadOnlineBySessionId($sessionId) {
        $online = $this->createQueryBuilder('o')->addSelect('user')
            ->leftJoin('o.user', 'user')
            ->where('o.active=1 and o.sessionId = :sessionId')
            ->setParameter('sessionId', $sessionId)
            ->getQuery()
            ->setMaxResults(1)
            ->getOneOrNullResult();
        return $online;
    }
    
    public function loadOnlineBySessionId2($sessionId) {
        /*$online = $this->getEntityManager()
            ->createQuery('SELECT l 
            FROM KaitekFrameworkBundle:Online o
            JOIN KaitekFrameworkBundle:LogDetail l with l.sessionId=o.sessionId
            WHERE o.sessionId = :sessionId')
            ->setParameter('sessionId', $sessionId)
            ->getResult();
        */
        $q = $this->createQueryBuilder('o')
            ->select('l.userId,o.active,u.fullname')
            ->leftJoin('KaitekFrameworkBundle:LogDetail', 'l', 'WITH', 'l.sessionId = o.sessionId')
            ->leftJoin('KaitekFrameworkBundle:User', 'u', 'WITH', 'u.id = l.userId');
            dump($q->getAllAliases());
            $q=$q->getQuery();
            dump($q->getDql());
            dump($q->getSql());
            $online =$q->getResult();
        /*$online = $this->createQueryBuilder('o')
            ->select('l,o')
            ->leftJoin('KaitekFrameworkBundle:LogDetail', 'l', 'WITH', 'l.sessionId = o.sessionId')
            ->where('o.sessionId = :sessionId')
            ->setParameter('sessionId', $sessionId)
            ->getQuery()
            ->getResult();*/
        return $online;
    }

}
